Index: uspace/app/vol/meson.build
===================================================================
--- uspace/app/vol/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/vol/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'device' ]
 src = files('vol.c')
Index: uspace/app/websrv/meson.build
===================================================================
--- uspace/app/websrv/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/websrv/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2010 Jiri Svoboda
+# Copyright (c) 2021 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'inet' ]
 src = files('websrv.c')
Index: uspace/drv/block/ahci/ahci.c
===================================================================
--- uspace/drv/block/ahci/ahci.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/block/ahci/ahci.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -131,7 +131,7 @@
 static int sata_devices_count = 0;
 
-/*----------------------------------------------------------------------------*/
-/*-- AHCI Interface ----------------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * AHCI Interface
+ */
 
 static ahci_iface_t ahci_interface = {
@@ -298,7 +298,7 @@
 }
 
-/*----------------------------------------------------------------------------*/
-/*-- AHCI Commands -----------------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * AHCI Commands
+ */
 
 /** Wait for interrupt event.
@@ -842,7 +842,7 @@
 }
 
-/*----------------------------------------------------------------------------*/
-/*-- Interrupts handling -----------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * Interrupts handling
+ */
 
 static irq_pio_range_t ahci_ranges[] = {
@@ -919,7 +919,7 @@
 }
 
-/*----------------------------------------------------------------------------*/
-/*-- AHCI and SATA device creating and initializing routines -----------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * AHCI and SATA device creating and initializing routines
+ */
 
 /** Allocate SATA device structure with buffers for hardware.
@@ -1273,7 +1273,7 @@
 }
 
-/*----------------------------------------------------------------------------*/
-/*-- Helpers and utilities ---------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * Helpers and utilities
+ */
 
 /** Convert SATA model name
@@ -1313,7 +1313,7 @@
 }
 
-/*----------------------------------------------------------------------------*/
-/*-- AHCI Main routine -------------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * AHCI Main routine
+ */
 
 int main(int argc, char *argv[])
Index: uspace/drv/block/ahci/ahci_hw.h
===================================================================
--- uspace/drv/block/ahci/ahci_hw.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/block/ahci/ahci_hw.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -36,14 +36,14 @@
 #include <stdint.h>
 
-/*----------------------------------------------------------------------------*/
-/*-- AHCI standard constants -------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * AHCI standard constants
+ */
 
 /** AHCI standard 1.3 - maximum ports. */
 #define AHCI_MAX_PORTS  32
 
-/*----------------------------------------------------------------------------*/
-/*-- AHCI PCI Registers ------------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * AHCI PCI Registers
+ */
 
 /** AHCI PCI register Identifiers offset. */
@@ -296,7 +296,7 @@
 } ahci_pcireg_mlat_t;
 
-/*----------------------------------------------------------------------------*/
-/*-- AHCI Memory Registers ---------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * AHCI Memory Registers
+ */
 
 /** Number of pages for ahci memory registers. */
Index: uspace/drv/block/ahci/ahci_sata.h
===================================================================
--- uspace/drv/block/ahci/ahci_sata.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/block/ahci/ahci_sata.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -36,7 +36,7 @@
 #include <stdint.h>
 
-/*----------------------------------------------------------------------------*/
-/*-- SATA Buffer Lengths -----------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * SATA Buffer Lengths
+ */
 
 /** Default sector size in bytes. */
@@ -49,7 +49,7 @@
 #define SATA_IDENTIFY_DEVICE_BUFFER_LENGTH  512
 
-/*----------------------------------------------------------------------------*/
-/*-- SATA Fis Frames ---------------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * SATA Fis Frames
+ */
 
 /** Sata FIS Type number. */
@@ -130,7 +130,7 @@
 } sata_ncq_command_frame_t;
 
-/*----------------------------------------------------------------------------*/
-/*-- SATA Identify device ----------------------------------------------------*/
-/*----------------------------------------------------------------------------*/
+/*
+ * SATA Identify device
+ */
 
 /** Data returned from identify device and identify packet device command. */
Index: uspace/drv/bus/usb/ehci/hc.c
===================================================================
--- uspace/drv/bus/usb/ehci/hc.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/bus/usb/ehci/hc.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -358,5 +358,5 @@
 		fibril_mutex_lock(&hc->guard);
 
-		usb_log_debug2("HC(%p): Scanning %lu pending endpoints", hc,
+		usb_log_debug2("HC(%p): Scanning %zu pending endpoints", hc,
 		    list_count(&hc->pending_endpoints));
 		list_foreach_safe(hc->pending_endpoints, current, next) {
Index: uspace/drv/bus/usb/uhci/hc.h
===================================================================
--- uspace/drv/bus/usb/uhci/hc.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/bus/usb/uhci/hc.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,4 +41,5 @@
 #include <fibril.h>
 #include <macros.h>
+#include <member.h>
 #include <stdbool.h>
 #include <ddi.h>
Index: uspace/drv/bus/usb/vhc/vhcd.h
===================================================================
--- uspace/drv/bus/usb/vhc/vhcd.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/bus/usb/vhc/vhcd.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,4 +41,5 @@
 #include <async.h>
 #include <macros.h>
+#include <member.h>
 
 #include <usb/host/hcd.h>
Index: uspace/drv/bus/usb/xhci/hc.h
===================================================================
--- uspace/drv/bus/usb/xhci/hc.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/bus/usb/xhci/hc.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -38,4 +38,5 @@
 
 #include <fibril_synch.h>
+#include <member.h>
 #include <usb/host/usb_transfer_batch.h>
 #include <usb/host/utility.h>
Index: uspace/drv/char/i8042/i8042.h
===================================================================
--- uspace/drv/char/i8042/i8042.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/char/i8042/i8042.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,6 +1,6 @@
 /*
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2006 Josef Cejka
  * Copyright (c) 2011 Jan Vesely
- * Copyright (c) 2017 Jiri Svoboda
  * All rights reserved.
  *
@@ -48,5 +48,8 @@
 #define NAME  "i8042"
 
-#define BUFFER_SIZE  12
+/** Buffer needs to be large enough for rate at which keyboard or mouse
+ * produces data (mouse produces data at faster rate).
+ */
+#define BUFFER_SIZE  64
 
 /** i8042 HW I/O interface */
@@ -77,5 +80,5 @@
 /** i8042 Controller. */
 typedef struct i8042 {
-	/**< I/O registers. */
+	/** I/O registers. */
 	i8042_regs_t *regs;
 	/** Keyboard port */
@@ -83,5 +86,5 @@
 	/** AUX port */
 	i8042_port_t *aux;
-	/** Prevents simultanous port writes.*/
+	/** Prevents simultanous port writes. */
 	fibril_mutex_t write_guard;
 } i8042_t;
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/char/ns8250/ns8250.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -157,5 +157,5 @@
 	/** Parent session */
 	async_sess_t *parent_sess;
-	/** I/O registers **/
+	/** I/O registers */
 	ns8250_regs_t *regs;
 	/** Are there any clients connected to the device? */
Index: uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.c
===================================================================
--- uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Jan Vesely
  * All rights reserved.
@@ -67,4 +67,5 @@
 static errno_t amdm37x_ddev_get_info(void *, ddev_info_t *);
 
+static errno_t amdm37x_gc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t amdm37x_gc_set_color(void *, gfx_color_t *);
 static errno_t amdm37x_gc_fill_rect(void *, gfx_rect_t *);
@@ -81,4 +82,5 @@
 
 gfx_context_ops_t amdm37x_gc_ops = {
+	.set_clip_rect = amdm37x_gc_set_clip_rect,
 	.set_color = amdm37x_gc_set_color,
 	.fill_rect = amdm37x_gc_fill_rect,
@@ -166,5 +168,5 @@
 	regs->irqenable = 0;
 
-	/* Pixel format specifics*/
+	/* Pixel format specifics */
 	uint32_t attrib_pixel_format = 0;
 	uint32_t control_data_lanes = 0;
@@ -291,4 +293,5 @@
 	dispc->rect.p1.x = x;
 	dispc->rect.p1.y = y;
+	dispc->clip_rect = dispc->rect;
 	dispc->size = size;
 
@@ -321,4 +324,23 @@
 }
 
+/** Set clipping rectangle on AMDM37x display controller.
+ *
+ * @param arg AMDM37x display controller
+ * @param rect Rectangle
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t amdm37x_gc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	amdm37x_dispc_t *dispc = (amdm37x_dispc_t *) arg;
+
+	if (rect != NULL)
+		gfx_rect_clip(rect, &dispc->rect, &dispc->clip_rect);
+	else
+		dispc->clip_rect = dispc->rect;
+
+	return EOK;
+}
+
 /** Set color on AMDM37x display controller.
  *
@@ -354,5 +376,5 @@
 
 	/* Make sure we have a sorted, clipped rectangle */
-	gfx_rect_clip(rect, &dispc->rect, &crect);
+	gfx_rect_clip(rect, &dispc->clip_rect, &crect);
 
 	for (y = crect.p0.y; y < crect.p1.y; y++) {
@@ -479,6 +501,6 @@
 	pbm.data = dcbm->alloc.pixels;
 
-	/* Transform AMDM37x bounding rectangle back to bitmap coordinate system */
-	gfx_rect_rtranslate(&offs, &dispc->rect, &skfbrect);
+	/* Transform AMDM37x clipping rectangle back to bitmap coordinate system */
+	gfx_rect_rtranslate(&offs, &dispc->clip_rect, &skfbrect);
 
 	/*
Index: uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.h
===================================================================
--- uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/fb/amdm37x_dispc/amdm37x_dispc.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Jan Vesely
  * All rights reserved.
@@ -63,4 +63,5 @@
 	pixel_t color;
 	gfx_rect_t rect;
+	gfx_rect_t clip_rect;
 	size_t size;
 	void *fb_data;
Index: uspace/drv/fb/kfb/port.c
===================================================================
--- uspace/drv/fb/kfb/port.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/fb/kfb/port.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2006 Jakub Vana
  * Copyright (c) 2006 Ondrej Palkovsky
@@ -69,4 +69,5 @@
 	sysarg_t paddr;
 	gfx_rect_t rect;
+	gfx_rect_t clip_rect;
 	size_t offset;
 	size_t scanline;
@@ -97,4 +98,5 @@
 static errno_t kfb_ddev_get_info(void *, ddev_info_t *);
 
+static errno_t kfb_gc_set_clip_rect(void *, gfx_rect_t *);
 static errno_t kfb_gc_set_color(void *, gfx_color_t *);
 static errno_t kfb_gc_fill_rect(void *, gfx_rect_t *);
@@ -111,4 +113,5 @@
 
 static gfx_context_ops_t kfb_gc_ops = {
+	.set_clip_rect = kfb_gc_set_clip_rect,
 	.set_color = kfb_gc_set_color,
 	.fill_rect = kfb_gc_fill_rect,
@@ -134,4 +137,23 @@
 	ddev_info_init(info);
 	info->rect = kfb->rect;
+	return EOK;
+}
+
+/** Set clipping rectangle on KFB.
+ *
+ * @param arg KFB
+ * @param rect Rectangle or @c NULL
+ *
+ * @return EOK on success or an error code
+ */
+static errno_t kfb_gc_set_clip_rect(void *arg, gfx_rect_t *rect)
+{
+	kfb_t *kfb = (kfb_t *) arg;
+
+	if (rect != NULL)
+		gfx_rect_clip(rect, &kfb->rect, &kfb->clip_rect);
+	else
+		kfb->clip_rect = kfb->rect;
+
 	return EOK;
 }
@@ -361,5 +383,4 @@
 }
 
-#include <stdio.h>
 static void kfb_client_conn(ipc_call_t *icall, void *arg)
 {
@@ -372,9 +393,4 @@
 	kfb = (kfb_t *) ddf_fun_data_get((ddf_fun_t *) arg);
 
-	printf("kfb_client_conn arg2=%lu arg3=%lu arg4=%lu\n",
-	    (unsigned long) ipc_get_arg2(icall),
-	    (unsigned long) ipc_get_arg3(icall),
-	    (unsigned long) ipc_get_arg4(icall));
-
 	gc_id = ipc_get_arg3(icall);
 
@@ -450,5 +466,4 @@
 
 	if (!present) {
-		ddf_fun_destroy(fun);
 		rc = ENOENT;
 		goto error;
@@ -501,4 +516,6 @@
 	kfb->rect.p1.x = width;
 	kfb->rect.p1.y = height;
+
+	kfb->clip_rect = kfb->rect;
 
 	kfb->paddr = paddr;
Index: uspace/drv/hid/usbhid/generic/hiddev.c
===================================================================
--- uspace/drv/hid/usbhid/generic/hiddev.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/hid/usbhid/generic/hiddev.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -120,5 +120,5 @@
 	}
 
-	/*! @todo This should probably be somehow atomic. */
+	/* TODO This should probably be somehow atomic. */
 	memcpy(buffer, hid_dev->input_report,
 	    hid_dev->input_report_size);
Index: uspace/drv/hid/usbhid/multimedia/keymap.c
===================================================================
--- uspace/drv/hid/usbhid/multimedia/keymap.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/hid/usbhid/multimedia/keymap.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -52,18 +52,18 @@
 	[0xb7] = 0,       /* Stop */
 	[0xb8] = 0,       /* Eject */
-	[0xcd] = 0/*KC_F2*/,   /* Play/Pause */
-	[0xe2] = 0/*KC_F3*/,   /* Mute */
-	[0xe9] = 0/*KC_F5*/,   /* Volume Increment */
-	[0xea] = 0/*KC_F4*/,   /* Volume Decrement */
-	[0x183] = 0/*KC_F1*/,      /* AL Consumer Control Configuration */
+	[0xcd] = 0,       /* Play/Pause */
+	[0xe2] = 0,       /* Mute */
+	[0xe9] = 0,       /* Volume Increment */
+	[0xea] = 0,       /* Volume Decrement */
+	[0x183] = 0,      /* AL Consumer Control Configuration */
 	[0x18a] = 0,      /* AL Email Reader */
 	[0x192] = 0,      /* AL Calculator */
 	[0x221] = 0,      /* AC Search */
-	[0x223] = 0/*KC_F6*/,      /* AC Home */
+	[0x223] = 0,      /* AC Home */
 	[0x224] = 0,      /* AC Back */
 	[0x225] = 0,      /* AC Forward */
 	[0x226] = 0,      /* AC Stop */
-	[0x227] = 0,  /* AC Refresh */
-	[0x22a] = 0   /* AC Bookmarks */
+	[0x227] = 0,      /* AC Refresh */
+	[0x22a] = 0       /* AC Bookmarks */
 };
 
@@ -84,5 +84,5 @@
 		return -1;
 
-	/*! @todo What if the usage is not in the table? */
+	/* TODO What if the usage is not in the table? */
 	key = map[usage];
 
Index: uspace/drv/hid/usbhid/usbhid.c
===================================================================
--- uspace/drv/hid/usbhid/usbhid.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/hid/usbhid/usbhid.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -342,5 +342,5 @@
 
 	if (hid_dev->max_input_report_size >= buffer_size) {
-		/*! @todo This should probably be atomic. */
+		/* TODO This should probably be atomic. */
 		memcpy(hid_dev->input_report, buffer, buffer_size);
 		hid_dev->input_report_size = buffer_size;
Index: uspace/drv/nic/ar9271/ar9271.h
===================================================================
--- uspace/drv/nic/ar9271/ar9271.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/nic/ar9271/ar9271.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -234,8 +234,8 @@
 	{ 0x0000801c, 0x12e0002b },
 	{ 0x00008318, 0x00003440 },
-	{ 0x00009804, 0x000003c0 },  /*< Note: overridden */
+	{ 0x00009804, 0x000003c0 },  /**< Note: overridden */
 	{ 0x00009820, 0x02020200 },
 	{ 0x00009824, 0x01000e0e },
-	{ 0x00009828, 0x0a020001 },  /*< Note: overridden */
+	{ 0x00009828, 0x0a020001 },  /**< Note: overridden */
 	{ 0x00009834, 0x00000e0e },
 	{ 0x00009838, 0x00000007 },
Index: uspace/drv/nic/ne2k/dp8390.h
===================================================================
--- uspace/drv/nic/ne2k/dp8390.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/nic/ne2k/dp8390.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -230,5 +230,5 @@
 	async_sess_t *parent_sess;
 	/* Device configuration */
-	void *base_port; /**< Port assigned from ISA configuration **/
+	void *base_port; /**< Port assigned from ISA configuration */
 	void *port;
 	void *data_port;
Index: uspace/drv/nic/rtl8139/driver.h
===================================================================
--- uspace/drv/nic/rtl8139/driver.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/drv/nic/rtl8139/driver.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -145,5 +145,7 @@
 } rtl8139_t;
 
-/* ***** Pointers casting - for both amd64 and ia32 ***** */
+/*
+ * Pointers casting - for both amd64 and ia32
+ */
 
 /** Cast pointer to uint32_t
Index: uspace/lib/bithenge/src/compound.c
===================================================================
--- uspace/lib/bithenge/src/compound.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/bithenge/src/compound.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -42,5 +42,7 @@
 #include "common.h"
 
-/***************** compose_transform                         *****************/
+/*
+ * compose_transform
+ */
 
 typedef struct {
@@ -148,5 +150,7 @@
 }
 
-/***************** if_transform                              *****************/
+/*
+ * if_transform
+ */
 
 typedef struct {
@@ -260,5 +264,7 @@
 }
 
-/***************** partial_transform                         *****************/
+/*
+ * partial_transform
+ */
 
 typedef struct {
Index: uspace/lib/bithenge/src/expression.c
===================================================================
--- uspace/lib/bithenge/src/expression.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/bithenge/src/expression.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -67,5 +67,7 @@
 }
 
-/***************** binary_expression                         *****************/
+/*
+ * binary_expression
+ */
 
 typedef struct {
@@ -281,5 +283,7 @@
 }
 
-/***************** in_node_expression                        *****************/
+/*
+ * in_node_expression
+ */
 
 static errno_t in_node_evaluate(bithenge_expression_t *self,
@@ -316,5 +320,7 @@
 }
 
-/***************** current_node_expression                   *****************/
+/*
+ * current_node_expression
+ */
 
 static errno_t current_node_evaluate(bithenge_expression_t *self,
@@ -347,5 +353,7 @@
 }
 
-/***************** param_expression                          *****************/
+/*
+ * param_expression
+ */
 
 typedef struct {
@@ -408,5 +416,7 @@
 }
 
-/***************** const_expression                          *****************/
+/*
+ * const_expression
+ */
 
 typedef struct {
@@ -478,5 +488,7 @@
 }
 
-/***************** scope_member_expression                   *****************/
+/*
+ * scope_member_expression
+ */
 
 typedef struct {
@@ -559,5 +571,7 @@
 }
 
-/***************** subblob_expression                        *****************/
+/*
+ * subblob_expression
+ */
 
 typedef struct {
@@ -685,5 +699,7 @@
 }
 
-/***************** param_wrapper                             *****************/
+/*
+ * param_wrapper
+ */
 
 typedef struct {
@@ -843,5 +859,7 @@
 }
 
-/***************** expression_transform           *****************/
+/*
+ * expression_transform
+ */
 
 /* Also used by inputless_transform. */
@@ -921,5 +939,7 @@
 }
 
-/***************** inputless_transform            *****************/
+/*
+ * inputless_transform
+ */
 
 static errno_t inputless_transform_prefix_length(bithenge_transform_t *base,
@@ -977,5 +997,7 @@
 }
 
-/***************** concat_blob                    *****************/
+/*
+ * concat_blob
+ */
 
 typedef struct {
Index: uspace/lib/bithenge/src/script.c
===================================================================
--- uspace/lib/bithenge/src/script.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/bithenge/src/script.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -450,5 +450,7 @@
 static bithenge_expression_t *parse_expression(state_t *state);
 
-/***************** Expressions                               *****************/
+/*
+ * Expressions
+ */
 
 /** @cond internal */
Index: uspace/lib/bithenge/src/sequence.c
===================================================================
--- uspace/lib/bithenge/src/sequence.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/bithenge/src/sequence.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -42,5 +42,7 @@
 #include "common.h"
 
-/***************** seq_node                                  *****************/
+/*
+ * seq_node
+ */
 
 typedef struct {
@@ -273,5 +275,7 @@
 }
 
-/***************** bithenge_new_struct                       *****************/
+/*
+ * bithenge_new_struct
+ */
 
 typedef struct {
@@ -626,5 +630,7 @@
 }
 
-/***************** bithenge_repeat_transform                 *****************/
+/*
+ * bithenge_repeat_transform
+ */
 
 /* TODO: ignore errors */
@@ -905,5 +911,7 @@
 }
 
-/***************** bithenge_do_while_transform               *****************/
+/*
+ * bithenge_do_while_transform
+ */
 
 typedef struct {
Index: uspace/lib/bithenge/src/transform.c
===================================================================
--- uspace/lib/bithenge/src/transform.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/bithenge/src/transform.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -44,5 +44,7 @@
 #include "common.h"
 
-/***************** transform                                 *****************/
+/*
+ * transform
+ */
 
 /** Initialize a new transform.
@@ -180,5 +182,7 @@
 }
 
-/***************** scope                                     *****************/
+/*
+ * scope
+ */
 
 /** Create a transform scope. It must be dereferenced with @a
@@ -429,5 +433,7 @@
 }
 
-/***************** barrier_transform                         *****************/
+/*
+ * barrier_transform
+ */
 
 typedef struct {
@@ -561,5 +567,7 @@
 }
 
-/***************** ascii                                     *****************/
+/*
+ * ascii
+ */
 
 static errno_t ascii_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
@@ -604,5 +612,7 @@
 };
 
-/***************** bit                                       *****************/
+/*
+ * bit
+ */
 
 static errno_t bit_prefix_apply(bithenge_transform_t *self,
@@ -632,5 +642,7 @@
 };
 
-/***************** bits_be, bits_le                          *****************/
+/*
+ * bits_be, bits_le
+ */
 
 typedef struct {
@@ -763,5 +775,7 @@
 };
 
-/***************** invalid                                   *****************/
+/*
+ * invalid
+ */
 
 static errno_t invalid_apply(bithenge_transform_t *self, bithenge_scope_t *scope,
@@ -781,5 +795,7 @@
 };
 
-/***************** known_length                              *****************/
+/*
+ * known_length
+ */
 
 static errno_t known_length_apply(bithenge_transform_t *self,
@@ -934,5 +950,7 @@
 /** @endcond */
 
-/***************** uint_be, uint_le                          *****************/
+/*
+ * uint_be, uint_le
+ */
 
 static errno_t uint_xe_prefix_apply(bithenge_transform_t *self,
@@ -1004,5 +1022,7 @@
 };
 
-/***************** zero_terminated                           *****************/
+/*
+ * zero_terminated
+ */
 
 static errno_t zero_terminated_apply(bithenge_transform_t *self,
Index: uspace/lib/block/meson.build
===================================================================
--- uspace/lib/block/meson.build	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/block/meson.build	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -28,3 +28,4 @@
 #
 
+deps = [ 'device' ]
 src = files('block.c')
Index: uspace/lib/c/generic/adt/hash_table.c
===================================================================
--- uspace/lib/c/generic/adt/hash_table.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/generic/adt/hash_table.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -52,4 +52,5 @@
 #include <adt/list.h>
 #include <assert.h>
+#include <member.h>
 #include <stdlib.h>
 #include <str.h>
@@ -331,5 +332,5 @@
 }
 
-/** Removes an item already present in the table. The item must be in the table.*/
+/** Removes an item already present in the table. The item must be in the table. */
 void hash_table_remove_item(hash_table_t *h, ht_link_t *item)
 {
@@ -393,5 +394,5 @@
 }
 
-/** Allocates and initializes the desired number of buckets. True if successful.*/
+/** Allocates and initializes the desired number of buckets. True if successful. */
 static bool alloc_table(size_t bucket_cnt, list_t **pbuckets)
 {
Index: uspace/lib/c/generic/adt/list.c
===================================================================
--- uspace/lib/c/generic/adt/list.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/generic/adt/list.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -41,4 +41,5 @@
 #include <adt/list.h>
 #include <stdbool.h>
+#include <stdint.h>
 
 /** Check for membership
@@ -100,7 +101,7 @@
  * @return		Number of items in the list.
  */
-unsigned long list_count(const list_t *list)
+size_t list_count(const list_t *list)
 {
-	unsigned long count = 0;
+	size_t count = 0;
 
 	link_t *link = list_first(list);
Index: uspace/lib/c/generic/capa.c
===================================================================
--- uspace/lib/c/generic/capa.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/generic/capa.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -34,7 +34,9 @@
  */
 
+#include <assert.h>
 #include <capa.h>
 #include <errno.h>
 #include <imath.h>
+#include <stddef.h>
 #include <stdio.h>
 #include <str.h>
Index: uspace/lib/c/generic/io/asprintf.c
===================================================================
--- uspace/lib/c/generic/io/asprintf.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/generic/io/asprintf.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -89,5 +89,5 @@
 	va_end(args2);
 
-	if (ret > 0) {
+	if (ret >= 0) {
 		*strp = malloc(ret + 1);
 		if (*strp == NULL)
Index: uspace/lib/c/generic/io/con_srv.c
===================================================================
--- uspace/lib/c/generic/io/con_srv.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/c/generic/io/con_srv.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -34,4 +34,5 @@
  * @brief Console protocol server stub
  */
+#include <as.h>
 #include <errno.h>
 #include <io/cons_event.h>
@@ -307,4 +308,82 @@
 }
 
+/** Create shared buffer for efficient rendering */
+static void con_map_srv(con_srv_t *srv, ipc_call_t *icall)
+{
+	errno_t rc;
+	charfield_t *buf;
+	sysarg_t cols, rows;
+	ipc_call_t call;
+	size_t size;
+
+	if (srv->srvs->ops->map == NULL || srv->srvs->ops->unmap == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	cols = ipc_get_arg1(icall);
+	rows = ipc_get_arg2(icall);
+
+	if (!async_share_in_receive(&call, &size)) {
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	/* Check size */
+	if (size != PAGES2SIZE(SIZE2PAGES(cols * rows * sizeof(charfield_t)))) {
+		async_answer_0(&call, EINVAL);
+		async_answer_0(icall, EINVAL);
+		return;
+	}
+
+	rc = srv->srvs->ops->map(srv, cols, rows, &buf);
+	if (rc != EOK) {
+		async_answer_0(&call, rc);
+		async_answer_0(icall, rc);
+		return;
+	}
+
+	rc = async_share_in_finalize(&call, buf, AS_AREA_READ |
+	    AS_AREA_WRITE | AS_AREA_CACHEABLE);
+	if (rc != EOK) {
+		srv->srvs->ops->unmap(srv);
+		async_answer_0(icall, EIO);
+		return;
+	}
+
+	async_answer_0(icall, EOK);
+}
+
+/** Delete shared buffer */
+static void con_unmap_srv(con_srv_t *srv, ipc_call_t *icall)
+{
+	if (srv->srvs->ops->unmap == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	srv->srvs->ops->unmap(srv);
+	async_answer_0(icall, EOK);
+}
+
+/** Update console area from shared buffer */
+static void con_update_srv(con_srv_t *srv, ipc_call_t *icall)
+{
+	sysarg_t c0, r0, c1, r1;
+
+	c0 = ipc_get_arg1(icall);
+	r0 = ipc_get_arg2(icall);
+	c1 = ipc_get_arg3(icall);
+	r1 = ipc_get_arg4(icall);
+
+	if (srv->srvs->ops->update == NULL) {
+		async_answer_0(icall, ENOTSUP);
+		return;
+	}
+
+	srv->srvs->ops->update(srv, c0, r0, c1, r1);
+	async_answer_0(icall, EOK);
+}
+
 static con_srv_t *con_srv_create(con_srvs_t *srvs)
 {
@@ -412,4 +491,13 @@
 			con_get_event_srv(srv, &call);
 			break;
+		case CONSOLE_MAP:
+			con_map_srv(srv, &call);
+			break;
+		case CONSOLE_UNMAP:
+			con_unmap_srv(srv, &call);
+			break;
+		case CONSOLE_UPDATE:
+			con_update_srv(srv, &call);
+			break;
 		default:
 			async_answer_0(&call, ENOTSUP);
